import 'package:insurance_card_scanner/models/scanned_card.dart';
import 'package:insurance_card_scanner/models/card_response_model.dart';

extension CardModelResponseExt on CardResponseModel {
  ScannedCard toCard() {
    return ScannedCard(
      id: id ?? '',
      name: details?.memberName?.value ?? '',
      memberId: details?.memberNumber?.value ?? '',
      groupId: details?.groupNumber?.value ?? '',
      date: DateTime.tryParse(createdAt ?? ''),
      dependents:
          details?.dependentNames?.map((e) => e.value.toString()).toList() ??
              [],
      planId: details?.planId?.value ?? '',
      planName: details?.planName?.value ?? '',
      payerName: details?.payerName?.value ?? '',
      rxBin: details?.rxBin?.value ?? '',
      rxPcn: details?.rxPcn?.value ?? '',
      rxGroup: details?.rxGroup?.value ?? '',
      cardSpecificId: details?.cardSpecificId?.value ?? '',
      startDate: details?.startDate?.value ?? '',
      state: _stateForString(state ?? ''),
      message: message,
    );
  }

  CardState _stateForString(String string) {
    switch (string.toLowerCase()) {
      case 'completed':
        return CardState.completed;
      case 'error':
        return CardState.error;
      case 'processing':
        return CardState.processing;
      default:
        return CardState.error;
    }
  }
}
